;;;--------------------------------------------------------------------;;;
;;;                          ;;;
;;;                   PosMark.LSP Version 2.0                          ;;;
;;;               AutoCAD 2000 (15) for Windows                     ;;;
;;;                           22.12.99                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;


;;
;; 2.0  AutoCAD 2000 (15)
;;     :
;;     1.      ( C:PosMark)

;=============================================================
;;;  

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;  OSNAP
(defun Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun Osnap_On  ()
	(setvar "OSMODE" sosnapm)
)

(defun SetOpt ()
; 
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

(defun RetOpt ()
; 
	(setvar "BLIPMODE" sblip)
	(setvar "CMDECHO" scmde)
)

(defun SaveLYype ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun RetLType ()

;   
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	(setvar "CELWEIGHT" oldWeight)
)

;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;;;   
;=============================================================



(defun c:PosMark (/ p1 p2 p3 x y x2 y2 i ch ch ss
                    PosCOL PosWD Scale
                    TxtH CurTxtStyle th Jut dxTxtPt TxtLen)

	;    
	;  DIMSCALE (  )
	;   - CONTINUOUS
	;   
	;  DIMCLRD (  )
	;    
	;  DIMLWD (  )
	
	;!!!
	;      
	;      0.0,   
	;      1.2    
	;  (   ),  
	;        
	;     

	(setq Scale (getvar "dimscale"))	;  
										;    
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 1)
	)


	(setq PosCOL (getvar "DIMCLRD"))	; , - 
									    ;  
	(setq PosWD (getvar "DIMLWD"))	    ; , - 
									    ;  

	(setq TxtH (* 1.2 Scale (getvar "DIMTXT")))	;  
											    ;   * 1.2

	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle)))) ;   
	                                                              
	
	;  
	(SaveLYype)	
	(setvar "CECOLOR" (rtos PosCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	(setvar "CELWEIGHT" PosWD)
    (Osnap_Off)
    (SetOpt)

    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (RetOpt)
        (Osnap_On)
        (RetLType)
        (GC)
    )

  (while (setq p2 (getpoint "\n   : "))

    (setq p1 (getpoint p2 "\n   : ")
	  x  (car p1)
	  y  (cadr p1)
	  x2 (car p2)
	  y2 (cadr p2)
	  i  0
    )

	(if (> x x2)
		(progn
			(setq Jut nil)
			(setq dxTxtPt 1.0)
		)
		(progn
			(setq Jut "_R")
			(setq dxTxtPt (- 2.0))
		)
	)

    ;(setq ch (getint "\n  : "))
    (setq ch (getstring "\n  : "))
	(if (= ch "") (setq ch nil))
	
	(if (not (null ch))   ;    
	    (progn
	    	(setq TxtLen (+ (getSymL ch (/ TxtH scale) scale) 2.0) )
	        (setq ss nil)
            (setq ss (ssadd))
	    	(command "_LINE" p1 p2 "")
    		(ssadd (entlast) ss)
    		(command "_DONUT" 0 (* 0.5 Scale) p2 "")
    		(ssadd (entlast) ss)
    		(UnBlock p2 ss)
    		(setq ss nil)
    	)
    )
    (setq p3 p1)
    (while ch
      ;(setq ch1 (itoa ch))
      (setq ch1 ch)

      (if (<= x x2)
	    (progn
	       (command
	          "_LINE"
	          p3
	          (list (- x TxtLen) (cadr p3))
	          ""
	       )
	       (if (= th 0.0)
	          (if (null Jut)
	          	(command
                    "_TEXT"
	             	(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             	TxtH
	             	0.0
	             	ch1
	          	)
	          	(command
	            	 "_TEXT"
	             	"_j"
	             	Jut
	             	(list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             	TxtH
	             	0.0
	             	ch1
	          	)
	          )
	          (if (null Jut)
               (command
	             "_TEXT"
	             (list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             0.0
	             ch1
	           )
               (command
	             "_TEXT"
	             "_j"
	             Jut
	             (list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	             0.0
	             ch1
	           )
	          )
	       )
	    )
	    (progn
		   (command
	  		   "_LINE"
	  		   p3
	  		   (list (+ x TxtLen) (cadr p3))
	  		   ""
	  	   )
	  	   (if (= th 0.0)
	  		   (if (null Jut)
	  		     (command 
	  	 		   "_TEXT"
	  			   (list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   TxtH
	  			   0.0
	  			   ch1
	  		     )
	  		     (command 
	  	 		   "_TEXT"
	  			   "_j"
	  			   Jut
	  			   (list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   TxtH
	  			   0.0
	  			   ch1
	  		     )
	  		   )
	  		   (if (null Jut)
	  		     (command 
	  	 		   "_TEXT"
	  			   (list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   0.0
	  			   ch1
	  		     )
	  		     (command 
	  	 		   "_TEXT"
	  			   "_j"
	  			   Jut
	  			   (list (+ x (* dxTxtPt Scale)) (+ (cadr p3) (* 1 Scale)))
	  			   0.0
	  			   ch1
	  		     )
	  		   )
	  	   )
	   )
      ) ;_end if

      (if (/= i 0)
	     (command "_LINE" (list x (+ (cadr p3) (* 8 Scale))) p3 "")
      )					;if;_ end if
      (setq p3 (list x (- (cadr p3) (* 8 Scale)))
	    i  (1+ i)
      )
      (setq ch (getstring "\n  : "))
      (if (= ch "") (setq ch nil))
      (if (not (null ch))   ;    
          (setq TxtLen (+ (getSymL ch (/ TxtH scale) scale) 2.0) )
      )

    ) ;_end while ch
    

  ) ;_end while p2
  (RetOpt)
  (Osnap_On)
  (RetLType)
  (command "_REDRAW")
  (if old_error (setq *error* old_error))			; Rest ore old *error* handler
) ;_end



;======================================
(princ "\n     PosMark.lsp  ")
(princ "\n***                   ACAD TOOLS.  UTILITES                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
